//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//
// Program        : Rational Driver
//
// Author         : Richard E. Pattis
//                  Computer Science Department
//                  Carnegie Mellon University
//                  5000 Forbes Avenue
//                  Pittsburgh, PA 15213-3891
//                  e-mail: pattis@cs.cmu.edu
//
// Maintainer     : Author
//
//
// Description:
//
//   This program implements a driver for the Rational class. Most of its
// menu selections allow the user to call the individual methods declared
//  in this class (all accessors) on an object that it constructs. Other
// menu items perform combinations of these methods. In this way,
// programmers can learn about this class by experimenting with
// its methods.
//
// Known Bugs     : None
//
// Future Plans   : None
//
// Program History:
//   9/11/01: R. Pattis - Operational in Java
//
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////


import edu.cmu.cs.pattis.cs151xx.Prompt;
import edu.cmu.cs.pattis.cs151xx.Rational;



public class Application {


  //Present menu and get user's choice
  
  private static char menuPrompt ()
  {
    System.out.println("\n\nAccessors      General");
    System.out.println("  + - add        h - harmonic sum: 1/1+1/2+...+1/n");
    System.out.println("  - - subtract   q - quit");
    System.out.println("  * - multiply");
    System.out.println("  / - divide");
    System.out.println("  a - abs");
    System.out.println("  n - negate");
    System.out.println("  r - reciprocal");
    System.out.println("  ? - compareTo/equals");
    System.out.println("  c - toDecimalString");
    
    return Prompt.forChar("\nEnter Command","+-*/anr?chq");
  }
  
  
  
  ////////////////
  //Driver Program
  ////////////////
  
 
	public static void main(String[] args)
	{
	  Rational left, right;
	  
	  for (;;)
	    try {
   	    char selection = menuPrompt();
  	    
        if (selection == '+') {
  	      left  = Rational.prompt("Enter left  Argument");
  	      right = Rational.prompt("Enter right Argument");
  	      System.out.println(left + " + " + right + " = " + (left.add(right)));
  	    
  	    }else if (selection == '-') {
           left  = Rational.prompt("Enter left  Argument");
  	       right = Rational.prompt("Enter right Argument");
  	       System.out.println(left + " - " + right + " = " + (left.subtract(right)));

  	    }else if (selection == '*') {
           left  = Rational.prompt("Enter left  Argument");
  	       right = Rational.prompt("Enter right Argument");
  	       System.out.println(left + " * " + right + " = " + (left.multiply(right)));

  	    }else if (selection == '/') {
           left  = Rational.prompt("Enter left  Argument");
  	       right = Rational.prompt("Enter right Argument");
  	       System.out.println(left + " / " + right + " = " + (left.divide(right)));

  	    }else if (selection == 'a') {
  	       right = Rational.prompt("Enter Argument");
  	       System.out.println("absolute value of " + right + " = " + right.abs());

  	    }else if (selection == 'n') {
  	       right = Rational.prompt("Enter Argument");
  	       System.out.println("negation of " + right + " = " + right.negate());

  	    }else if (selection == 'r') {
  	       right = Rational.prompt("Enter Argument");
  	       System.out.println("reciprocal of " + right + " = " + right.reciprocal());

  	    }else if (selection == '?') {
  	      left  = Rational.prompt("Enter left  Argument");
  	      right = Rational.prompt("Enter right Argument");
  	      System.out.println(left + ".equals(" + right + ") = " + left.equals(right));
  	      System.out.println(left + ".compareTo(" + right + ") = " + left.compareTo(right));

  	    }else if (selection == 'c') {
  	      right = Rational.prompt("Enter Argument");
  	      int decs = Prompt.forInt("Enter decimal places");
  	      System.out.println("Decimal of " + right + " = " + right.toDecimalString(decs));

  	    }else if (selection == 'h') {
  	      int bound = Prompt.forInt("  Enter n",1,21);
         
  		    Rational sum = new Rational();
  		    for (int i=1; i<=bound;i++)
  		      sum = sum.add(new Rational(1,i));
  		     
  		    System.out.println("0 + 1/1 + 1/2 + ... + 1/"+bound+" = " + sum);
          int decs  = Prompt.forInt("  Enter decimal places");

  		    System.out.println("0 + 1/1 + 1/2 + ... + 1/"+bound+" = " + sum.toDecimalString(decs));

  	     }else if (selection == 'q')
  	        break;

  	     else System.out.println("Unknown command");
	     
      }catch(Exception e) {
        System.out.println("  Exception Caught/Handled: "+e.getMessage());
      }
  }
}
